AbstractDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser

## Class AbstractDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<java.lang.Object>
  - - com.fasterxml.jackson.databind.deser.AbstractDeserializer

- All Implemented Interfaces:
    java.io.Serializable

      public class AbstractDeserializer
      extends JsonDeserializer<java.lang.Object>
      implements java.io.Serializable

  Deserializer only used for abstract types used as placeholders during polymorphic type handling deserialization. If so, there is no real deserializer associated with nominal type, just `TypeDeserializer`; and any calls that do not pass such resolver will result in an error.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `_acceptBoolean`
    `protected boolean` | `_acceptDouble`
    `protected boolean` | `_acceptInt`
    `protected boolean` | `_acceptString`
    `protected java.util.Map<java.lang.String,SettableBeanProperty>` | `_backRefProperties`
    `protected JavaType` | `_baseType`
    `protected ObjectIdReader` | `_objectIdReader`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractDeserializer(BeanDescription beanDesc)`
    `` | `AbstractDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, java.util.Map<java.lang.String,SettableBeanProperty> backRefProps)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Object` | `_deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called in cases where it looks like we got an Object Id to parse and use as a reference.
    `protected java.lang.Object` | `_deserializeIfNatural(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `static AbstractDeserializer` | `constructForNonPOJO(BeanDescription beanDesc)` Factory method used when constructing instances for non-POJO types, like `Map`s.
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `java.lang.Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
    `SettableBeanProperty` | `findBackReference(java.lang.String logicalName)` Method called by `BeanDeserializer` to resolve back reference part of managed references.
    `ObjectIdReader` | `getObjectIdReader()` Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).
    `java.lang.Class<?>` | `handledType()` Method for accessing type of values this deserializer produces.
    `boolean` | `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _baseType

          protected final JavaType _baseType

    - #### _objectIdReader

          protected final ObjectIdReader _objectIdReader

    - #### _backRefProperties

          protected final java.util.Map<java.lang.String,SettableBeanProperty> _backRefProperties

    - #### _acceptString

          protected final boolean _acceptString

    - #### _acceptBoolean

          protected final boolean _acceptBoolean

    - #### _acceptInt

          protected final boolean _acceptInt

    - #### _acceptDouble

          protected final boolean _acceptDouble

  - ### Constructor Detail

    - #### AbstractDeserializer

          public AbstractDeserializer(BeanDeserializerBuilder builder,
                              BeanDescription beanDesc,
                              java.util.Map<java.lang.String,SettableBeanProperty> backRefProps)

    - #### AbstractDeserializer

          protected AbstractDeserializer(BeanDescription beanDesc)

  - ### Method Detail

    - #### constructForNonPOJO

          public static AbstractDeserializer constructForNonPOJO(BeanDescription beanDesc)

      Factory method used when constructing instances for non-POJO types, like `Map`s.
      Since:
        2.3

    - #### handledType

          public java.lang.Class<?> handledType()

      Description copied from class: `JsonDeserializer`
      Method for accessing type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

      Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

      Overrides:
        `handledType` in class `JsonDeserializer<java.lang.Object>`

    - #### isCachable

          public boolean isCachable()

      Description copied from class: `JsonDeserializer`
      Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

      Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

      Default implementation returns false, to indicate that no caching is done.

      Overrides:
        `isCachable` in class `JsonDeserializer<java.lang.Object>`

    - #### getObjectIdReader

          public ObjectIdReader getObjectIdReader()

      Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).
      Overrides:
        `getObjectIdReader` in class `JsonDeserializer<java.lang.Object>`
      Returns:
        ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.

    - #### findBackReference

          public SettableBeanProperty findBackReference(java.lang.String logicalName)

      Method called by `BeanDeserializer` to resolve back reference part of managed references.
      Overrides:
        `findBackReference` in class `JsonDeserializer<java.lang.Object>`

    - #### deserializeWithType

          public java.lang.Object deserializeWithType(com.fasterxml.jackson.core.JsonParser p,
                                             DeserializationContext ctxt,
                                             TypeDeserializer typeDeserializer)
                                               throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

      Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

      Overrides:
        `deserializeWithType` in class `JsonDeserializer<java.lang.Object>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `java.io.IOException`

    - #### deserialize

          public java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt)
                                       throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### _deserializeIfNatural

          protected java.lang.Object _deserializeIfNatural(com.fasterxml.jackson.core.JsonParser p,
                                               DeserializationContext ctxt)
                                                    throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _deserializeFromObjectId

          protected java.lang.Object _deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt)
                                                       throws java.io.IOException

      Method called in cases where it looks like we got an Object Id to parse and use as a reference.
      Throws:
        `java.io.IOException`